Index: Singular/grammar.cc
===================================================================
--- Singular/grammar.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ Singular/grammar.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -1525,7 +1527,7 @@
       99,    67,    99,    99,    66,    99,    66,    99,    16,   112,
      120,   121,   121,   112,   111,   111,   112,    95,    11,    99,
-      86,    94,     3,     4,     7,     9,    10,    87,    88,    89,
-      90,    91,    93,    96,    97,   101,   112,   112,   111,    12,
-      86,    94,    95,   127,    99,   110,    94,   110,   112,    99,
+      86,    94,   127,     3,     4,     7,     9,    10,    87,    88,
+      89,    90,    91,    93,    96,    97,   101,   112,   112,   111,
+      12,    94,    95,   127,    99,   110,    94,   110,   112,    99,
       99,    99,    99,    99,    99,   112,    67,    99,   112,   122,
      112,   112,   112,   112,   112,   112,   112,   100,   111,   112,
@@ -2905,5 +2907,5 @@
     {
             if (iiARROW(&(yyval.lv),(yyvsp[(1) - (3)].name),(yyvsp[(3) - (3)].name))) YYERROR;
-            omFree((ADDRESS)(yyvsp[(3) - (3)].name))
+            omFree((ADDRESS)(yyvsp[(3) - (3)].name));
           ;}
     break;
@@ -2932,34 +2934,8 @@
     break;
 
-  case 68:
-
-/* Line 1464 of yacc.c  */
-#line 674 "grammar.y"
-    {
-            (yyval.lv) = (yyvsp[(1) - (1)].lv);
-          ;}
-    break;
-
-  case 69:
-
-/* Line 1464 of yacc.c  */
-#line 680 "grammar.y"
-    {
-            /*if ($1.typ == eunknown) YYERROR;*/
-            (yyval.lv) = (yyvsp[(1) - (1)].lv);
-          ;}
-    break;
-
-  case 70:
-
-/* Line 1464 of yacc.c  */
-#line 684 "grammar.y"
-    { (yyval.lv) = (yyvsp[(1) - (1)].lv); ;}
-    break;
-
   case 71:
 
 /* Line 1464 of yacc.c  */
-#line 686 "grammar.y"
+#line 679 "grammar.y"
     {
             if(iiExprArith3(&(yyval.lv),'[',&(yyvsp[(1) - (6)].lv),&(yyvsp[(3) - (6)].lv),&(yyvsp[(5) - (6)].lv))) YYERROR;
@@ -2970,5 +2946,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 690 "grammar.y"
+#line 683 "grammar.y"
     {
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (4)].lv),'[',&(yyvsp[(3) - (4)].lv))) YYERROR;
@@ -2979,5 +2955,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 694 "grammar.y"
+#line 687 "grammar.y"
     {
             if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
@@ -2988,5 +2964,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 698 "grammar.y"
+#line 691 "grammar.y"
     {
             if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
@@ -2997,5 +2973,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 702 "grammar.y"
+#line 695 "grammar.y"
     {
             if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
@@ -3006,5 +2982,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 706 "grammar.y"
+#line 699 "grammar.y"
     {
             if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
@@ -3015,5 +2991,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 710 "grammar.y"
+#line 703 "grammar.y"
     {
             if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), (yyvsp[(5) - (6)].i), NULL)) YYERROR;
@@ -3024,5 +3000,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 714 "grammar.y"
+#line 707 "grammar.y"
     {
             if (iiApply(&(yyval.lv), &(yyvsp[(3) - (6)].lv), 0, &(yyvsp[(5) - (6)].lv))) YYERROR;
@@ -3033,5 +3009,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 718 "grammar.y"
+#line 711 "grammar.y"
     {
             (yyval.lv)=(yyvsp[(2) - (3)].lv);
@@ -3042,5 +3018,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 722 "grammar.y"
+#line 715 "grammar.y"
     {
             #ifdef SIQ
@@ -3064,5 +3040,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 739 "grammar.y"
+#line 732 "grammar.y"
     {
             iiTestAssume(&(yyvsp[(2) - (5)].lv),&(yyvsp[(4) - (5)].lv));
@@ -3075,5 +3051,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 745 "grammar.y"
+#line 738 "grammar.y"
     {
             #ifdef SIQ
@@ -3086,5 +3062,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 751 "grammar.y"
+#line 744 "grammar.y"
     {
             #ifdef SIQ
@@ -3101,5 +3077,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 763 "grammar.y"
+#line 756 "grammar.y"
     {
             #ifdef SIQ
@@ -3112,5 +3088,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 771 "grammar.y"
+#line 764 "grammar.y"
     {
             #ifdef SIQ
@@ -3123,5 +3099,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 779 "grammar.y"
+#line 772 "grammar.y"
     {
             #ifdef SIQ
@@ -3134,5 +3110,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 788 "grammar.y"
+#line 781 "grammar.y"
     {
             if(iiExprArith1(&(yyval.lv),&(yyvsp[(1) - (2)].lv),PLUSPLUS)) YYERROR;
@@ -3143,5 +3119,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 792 "grammar.y"
+#line 785 "grammar.y"
     {
             if(iiExprArith1(&(yyval.lv),&(yyvsp[(1) - (2)].lv),MINUSMINUS)) YYERROR;
@@ -3152,5 +3128,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 796 "grammar.y"
+#line 789 "grammar.y"
     {
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),'+',&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3161,5 +3137,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 800 "grammar.y"
+#line 793 "grammar.y"
     {
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),'-',&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3170,5 +3146,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 804 "grammar.y"
+#line 797 "grammar.y"
     { /* also for *,% */
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),(yyvsp[(2) - (3)].i),&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3179,5 +3155,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 808 "grammar.y"
+#line 801 "grammar.y"
     {
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),'^',&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3188,5 +3164,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 812 "grammar.y"
+#line 805 "grammar.y"
     { /* also for > */
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),(yyvsp[(2) - (3)].i),&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3197,5 +3173,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 816 "grammar.y"
+#line 809 "grammar.y"
     { /* also for |*/
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),(yyvsp[(2) - (3)].i),&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3206,5 +3182,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 820 "grammar.y"
+#line 813 "grammar.y"
     {
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),NOTEQUAL,&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3215,5 +3191,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 824 "grammar.y"
+#line 817 "grammar.y"
     {
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),EQUAL_EQUAL,&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3224,5 +3200,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 828 "grammar.y"
+#line 821 "grammar.y"
     {
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),DOTDOT,&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3233,5 +3209,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 832 "grammar.y"
+#line 825 "grammar.y"
     {
             if(iiExprArith2(&(yyval.lv),&(yyvsp[(1) - (3)].lv),':',&(yyvsp[(3) - (3)].lv))) YYERROR;
@@ -3242,5 +3218,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 836 "grammar.y"
+#line 829 "grammar.y"
     {
             if (siq>0)
@@ -3259,5 +3235,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 848 "grammar.y"
+#line 841 "grammar.y"
     {
             if(iiExprArith1(&(yyval.lv),&(yyvsp[(2) - (2)].lv),'-')) YYERROR;
@@ -3265,15 +3241,8 @@
     break;
 
-  case 101:
-
-/* Line 1464 of yacc.c  */
-#line 854 "grammar.y"
-    { (yyval.lv) = (yyvsp[(1) - (2)].lv); ;}
-    break;
-
   case 102:
 
 /* Line 1464 of yacc.c  */
-#line 856 "grammar.y"
+#line 849 "grammar.y"
     {
             if ((yyvsp[(1) - (2)].lv).rtyp==0)
@@ -3295,5 +3264,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 876 "grammar.y"
+#line 869 "grammar.y"
     {
             if ((yyvsp[(2) - (3)].lv).Typ()!=STRING_CMD)
@@ -3309,5 +3278,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 888 "grammar.y"
+#line 881 "grammar.y"
     {
             if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
@@ -3319,5 +3288,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 893 "grammar.y"
+#line 886 "grammar.y"
     {
             if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
@@ -3329,5 +3298,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 898 "grammar.y"
+#line 891 "grammar.y"
     {
             if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&(currRing->idroot), TRUE)) YYERROR;
@@ -3338,5 +3307,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 902 "grammar.y"
+#line 895 "grammar.y"
     {
             if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&(currRing->idroot), TRUE)) YYERROR;
@@ -3347,5 +3316,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 906 "grammar.y"
+#line 899 "grammar.y"
     {
             int r; TESTSETINT((yyvsp[(4) - (8)].lv),r);
@@ -3362,5 +3331,5 @@
               if (IDMATRIX(h)==NULL) YYERROR;
             }
-            else if ((yyvsp[(1) - (8)].i) == INTMAT_CMD)
+            else if (((yyvsp[(1) - (8)].i) == INTMAT_CMD)||((yyvsp[(1) - (8)].i) == BIGINTMAT_CMD))
             {
               if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (8)].lv),myynest,(yyvsp[(1) - (8)].i),&((yyvsp[(2) - (8)].lv).req_packhdl->idroot)))
@@ -3368,18 +3337,16 @@
               v=&(yyval.lv);
               h=(idhdl)v->data;
-              delete IDINTVEC(h);
-              IDINTVEC(h) = new intvec(r,c,0);
+              if ((yyvsp[(1) - (8)].i)==INTMAT_CMD)
+              {
+                delete IDINTVEC(h);
+                IDINTVEC(h) = new intvec(r,c,0);
+              }
+              else
+              {
+                delete IDBIMAT(h);
+                IDBIMAT(h) = new bigintmat(r, c, coeffs_BIGINT);
+              }
               if (IDINTVEC(h)==NULL) YYERROR;
             }
-            else /* BIGINTMAT_CMD */
-            {
-              if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (8)].lv),myynest,(yyvsp[(1) - (8)].i),&((yyvsp[(2) - (8)].lv).req_packhdl->idroot)))
-                YYERROR;
-              v=&(yyval.lv);
-              h=(idhdl)v->data;
-              delete IDBIMAT(h);
-              IDBIMAT(h) = new bigintmat(r, c, coeffs_BIGINT);
-              if (IDBIMAT(h)==NULL) YYERROR;
-            }
           ;}
     break;
@@ -3388,5 +3355,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 942 "grammar.y"
+#line 933 "grammar.y"
     {
             if ((yyvsp[(1) - (2)].i) == MATRIX_CMD)
@@ -3394,23 +3361,21 @@
               if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&(currRing->idroot), TRUE)) YYERROR;
             }
-            else if ((yyvsp[(1) - (2)].i) == INTMAT_CMD)
+            else if (((yyvsp[(1) - (2)].i) == INTMAT_CMD)||((yyvsp[(1) - (2)].i) == BIGINTMAT_CMD))
             {
               if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
                 YYERROR;
-              leftv v=&(yyval.lv);
-              idhdl h;
-              do
+              if ((yyvsp[(1) - (2)].i) == INTMAT_CMD)
               {
-                 h=(idhdl)v->data;
-                 delete IDINTVEC(h);
-                 IDINTVEC(h) = new intvec(1,1,0);
-                 v=v->next;
-              } while (v!=NULL);
+                leftv v=&(yyval.lv);
+                idhdl h;
+                do
+                {
+                  h=(idhdl)v->data;
+                  delete IDINTVEC(h);
+                  IDINTVEC(h) = new intvec(1,1,0);
+                  v=v->next;
+                } while (v!=NULL);
+              }
             }
-            else /* BIGINTMAT_CMD */
-            {
-              if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
-                YYERROR;
-            }
           ;}
     break;
@@ -3419,5 +3384,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 968 "grammar.y"
+#line 957 "grammar.y"
     {
             int t=(yyvsp[(1) - (3)].lv).Typ();
@@ -3445,5 +3410,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 989 "grammar.y"
+#line 978 "grammar.y"
     {
             if (iiDeclCommand(&(yyval.lv),&(yyvsp[(2) - (2)].lv),myynest,(yyvsp[(1) - (2)].i),&((yyvsp[(2) - (2)].lv).req_packhdl->idroot)))
@@ -3455,5 +3420,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1002 "grammar.y"
+#line 991 "grammar.y"
     {
             leftv v = &(yyvsp[(2) - (5)].lv);
@@ -3471,5 +3436,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1016 "grammar.y"
+#line 1005 "grammar.y"
     {
           // let rInit take care of any errors
@@ -3481,5 +3446,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1024 "grammar.y"
+#line 1013 "grammar.y"
     {
             memset(&(yyval.lv),0,sizeof((yyval.lv)));
@@ -3495,5 +3460,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1033 "grammar.y"
+#line 1022 "grammar.y"
     {
             memset(&(yyval.lv),0,sizeof((yyval.lv)));
@@ -3542,5 +3507,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1079 "grammar.y"
+#line 1068 "grammar.y"
     {
             (yyval.lv) = (yyvsp[(1) - (3)].lv);
@@ -3553,5 +3518,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1089 "grammar.y"
+#line 1078 "grammar.y"
     {
             (yyval.lv) = (yyvsp[(2) - (3)].lv);
@@ -3562,5 +3527,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1095 "grammar.y"
+#line 1084 "grammar.y"
     {
             expected_parms = TRUE;
@@ -3568,36 +3533,15 @@
     break;
 
-  case 124:
-
-/* Line 1464 of yacc.c  */
-#line 1102 "grammar.y"
-    { (yyval.i) = (yyvsp[(1) - (1)].i); ;}
-    break;
-
-  case 125:
-
-/* Line 1464 of yacc.c  */
-#line 1104 "grammar.y"
-    { (yyval.i) = (yyvsp[(1) - (1)].i); ;}
-    break;
-
-  case 126:
+  case 127:
+
+/* Line 1464 of yacc.c  */
+#line 1101 "grammar.y"
+    { newFile((yyvsp[(2) - (2)].name)); omFree((yyvsp[(2) - (2)].name)); ;}
+    break;
+
+  case 128:
 
 /* Line 1464 of yacc.c  */
 #line 1106 "grammar.y"
-    { (yyval.i) = (yyvsp[(1) - (1)].i); ;}
-    break;
-
-  case 127:
-
-/* Line 1464 of yacc.c  */
-#line 1115 "grammar.y"
-    { newFile((yyvsp[(2) - (2)].name)); omFree((yyvsp[(2) - (2)].name)); ;}
-    break;
-
-  case 128:
-
-/* Line 1464 of yacc.c  */
-#line 1120 "grammar.y"
     {
             feHelp((yyvsp[(2) - (3)].name));
@@ -3609,5 +3553,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1125 "grammar.y"
+#line 1111 "grammar.y"
     {
             feHelp(NULL);
@@ -3618,5 +3562,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1132 "grammar.y"
+#line 1118 "grammar.y"
     {
             singular_example((yyvsp[(2) - (3)].name));
@@ -3628,5 +3572,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1140 "grammar.y"
+#line 1126 "grammar.y"
     {
           if (basePack!=(yyvsp[(2) - (2)].lv).req_packhdl)
@@ -3642,5 +3586,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1152 "grammar.y"
+#line 1138 "grammar.y"
     {
           leftv v=&(yyvsp[(2) - (2)].lv);
@@ -3664,5 +3608,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1169 "grammar.y"
+#line 1155 "grammar.y"
     {
           leftv v=&(yyvsp[(3) - (3)].lv);
@@ -3686,5 +3630,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1189 "grammar.y"
+#line 1175 "grammar.y"
     {
             list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
@@ -3695,5 +3639,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1193 "grammar.y"
+#line 1179 "grammar.y"
     {
             list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
@@ -3704,5 +3648,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1197 "grammar.y"
+#line 1183 "grammar.y"
     {
             if ((yyvsp[(3) - (4)].i)==QRING_CMD) (yyvsp[(3) - (4)].i)=RING_CMD;
@@ -3714,5 +3658,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1202 "grammar.y"
+#line 1188 "grammar.y"
     {
             list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
@@ -3723,5 +3667,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1206 "grammar.y"
+#line 1192 "grammar.y"
     {
             list_cmd(RING_CMD,NULL,"// ",TRUE);
@@ -3732,5 +3676,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1210 "grammar.y"
+#line 1196 "grammar.y"
     {
             list_cmd((yyvsp[(3) - (4)].i),NULL,"// ",TRUE);
@@ -3741,5 +3685,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1214 "grammar.y"
+#line 1200 "grammar.y"
     {
             list_cmd(PROC_CMD,NULL,"// ",TRUE);
@@ -3750,5 +3694,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1218 "grammar.y"
+#line 1204 "grammar.y"
     {
             list_cmd(0,(yyvsp[(3) - (4)].lv).Fullname(),"// ",TRUE);
@@ -3760,5 +3704,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1223 "grammar.y"
+#line 1209 "grammar.y"
     {
             if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
@@ -3771,5 +3715,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1229 "grammar.y"
+#line 1215 "grammar.y"
     {
             if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
@@ -3782,5 +3726,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1235 "grammar.y"
+#line 1221 "grammar.y"
     {
             if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
@@ -3793,5 +3737,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1241 "grammar.y"
+#line 1227 "grammar.y"
     {
             if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
@@ -3804,5 +3748,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1247 "grammar.y"
+#line 1233 "grammar.y"
     {
             if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
@@ -3815,5 +3759,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1253 "grammar.y"
+#line 1239 "grammar.y"
     {
             if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
@@ -3826,5 +3770,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1259 "grammar.y"
+#line 1245 "grammar.y"
     {
             if((yyvsp[(3) - (6)].lv).Typ() == PACKAGE_CMD)
@@ -3837,5 +3781,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1271 "grammar.y"
+#line 1257 "grammar.y"
     {
             list_cmd(-1,NULL,"// ",TRUE);
@@ -3846,5 +3790,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1277 "grammar.y"
+#line 1263 "grammar.y"
     { yyInRingConstruction = TRUE; ;}
     break;
@@ -3853,5 +3797,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1286 "grammar.y"
+#line 1272 "grammar.y"
     {
             const char *ring_name = (yyvsp[(2) - (8)].lv).name;
@@ -3891,5 +3835,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1319 "grammar.y"
+#line 1305 "grammar.y"
     {
             const char *ring_name = (yyvsp[(2) - (2)].lv).name;
@@ -3903,5 +3847,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1326 "grammar.y"
+#line 1312 "grammar.y"
     {
             yyInRingConstruction = FALSE;
@@ -3913,5 +3857,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1331 "grammar.y"
+#line 1317 "grammar.y"
     {
           yyInRingConstruction = FALSE;
@@ -3928,8 +3872,8 @@
 
 /* Line 1464 of yacc.c  */
-#line 1344 "grammar.y"
+#line 1330 "grammar.y"
     {
             if (((yyvsp[(1) - (2)].i)!=LIB_CMD)||(jjLOAD((yyvsp[(2) - (2)].name),TRUE))) YYERROR;
-	    omFree((yyvsp[(2) - (2)].name));
+            omFree((yyvsp[(2) - (2)].name));
           ;}
     break;
@@ -3938,5 +3882,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1354 "grammar.y"
+#line 1340 "grammar.y"
     {
             if (((yyvsp[(1) - (2)].i)==KEEPRING_CMD) && (myynest==0))
@@ -4008,5 +3952,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1422 "grammar.y"
+#line 1408 "grammar.y"
     {
             type_cmd(&((yyvsp[(2) - (2)].lv)));
@@ -4017,5 +3961,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1426 "grammar.y"
+#line 1412 "grammar.y"
     {
             //Print("typ is %d, rtyp:%d\n",$1.Typ(),$1.rtyp);
@@ -4045,5 +3989,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1455 "grammar.y"
+#line 1441 "grammar.y"
     {
             int i; TESTSETINT((yyvsp[(3) - (5)].lv),i);
@@ -4063,5 +4007,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1468 "grammar.y"
+#line 1454 "grammar.y"
     {
             if (currentVoice->ifsw==1)
@@ -4085,5 +4029,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1485 "grammar.y"
+#line 1471 "grammar.y"
     {
             int i; TESTSETINT((yyvsp[(3) - (5)].lv),i);
@@ -4099,5 +4043,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1494 "grammar.y"
+#line 1480 "grammar.y"
     {
             if (exitBuffer(BT_break)) YYERROR;
@@ -4109,5 +4053,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1499 "grammar.y"
+#line 1485 "grammar.y"
     {
             if (contBuffer(BT_break)) YYERROR;
@@ -4119,5 +4063,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1507 "grammar.y"
+#line 1493 "grammar.y"
     {
             /* -> if(!$2) break; $3; continue;*/
@@ -4133,5 +4077,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1519 "grammar.y"
+#line 1505 "grammar.y"
     {
             /* $2 */
@@ -4154,5 +4098,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1538 "grammar.y"
+#line 1524 "grammar.y"
     {
             idhdl h = enterid((yyvsp[(2) - (3)].name),myynest,PROC_CMD,&IDROOT,TRUE);
@@ -4169,5 +4113,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1548 "grammar.y"
+#line 1534 "grammar.y"
     {
             idhdl h = enterid((yyvsp[(1) - (3)].name),myynest,PROC_CMD,&IDROOT,TRUE);
@@ -4193,5 +4137,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1567 "grammar.y"
+#line 1553 "grammar.y"
     {
             omFree((ADDRESS)(yyvsp[(3) - (4)].name));
@@ -4218,5 +4162,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1590 "grammar.y"
+#line 1576 "grammar.y"
     {
             // decl. of type proc p(int i)
@@ -4229,5 +4173,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1596 "grammar.y"
+#line 1582 "grammar.y"
     {
             // decl. of type proc p(i)
@@ -4243,5 +4187,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1608 "grammar.y"
+#line 1594 "grammar.y"
     {
             iiRETURNEXPR.Copy(&(yyvsp[(3) - (4)].lv));
@@ -4254,5 +4198,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 1614 "grammar.y"
+#line 1600 "grammar.y"
     {
             if ((yyvsp[(1) - (3)].i)==RETURN)
@@ -4268,5 +4212,5 @@
 
 /* Line 1464 of yacc.c  */
-#line 4269 "grammar.cc"
+#line 4213 "grammar.cc"
       default: break;
     }
Index: Singular/grammar.y
===================================================================
--- Singular/grammar.y	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ Singular/grammar.y	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -654,5 +654,5 @@
           {
             if (iiARROW(&$$,$1,$3)) YYERROR;
-            omFree((ADDRESS)$3)
+            omFree((ADDRESS)$3);
           }
         | '(' exprlist ')'    { $$ = $2; }
@@ -672,15 +672,8 @@
           }
         | expr
-          {
-            $$ = $1;
-          }
         ;
 
 expr:   expr_arithmetic
-          {
-            /*if ($1.typ == eunknown) YYERROR;*/
-            $$ = $1;
-          }
-        | elemexpr       { $$ = $1; }
+        | elemexpr
         | expr '[' expr ',' expr ']'
           {
@@ -852,6 +845,6 @@
 
 left_value:
-        declare_ip_variable cmdeq  { $$ = $1; }
-        | exprlist '='
+        declare_ip_variable cmdeq
+        | exprlist cmdeq
           {
             if ($1.rtyp==0)
@@ -918,5 +911,5 @@
               if (IDMATRIX(h)==NULL) YYERROR;
             }
-            else if ($1 == INTMAT_CMD)
+            else if (($1 == INTMAT_CMD)||($1 == BIGINTMAT_CMD))
             {
               if (iiDeclCommand(&$$,&$2,myynest,$1,&($2.req_packhdl->idroot)))
@@ -924,43 +917,39 @@
               v=&$$;
               h=(idhdl)v->data;
-              delete IDINTVEC(h);
-              IDINTVEC(h) = new intvec(r,c,0);
+              if ($1==INTMAT_CMD)
+              {
+                delete IDINTVEC(h);
+                IDINTVEC(h) = new intvec(r,c,0);
+              }
+              else
+              {
+                delete IDBIMAT(h);
+                IDBIMAT(h) = new bigintmat(r, c, coeffs_BIGINT);
+              }
               if (IDINTVEC(h)==NULL) YYERROR;
             }
-            else /* BIGINTMAT_CMD */
+          }
+        | mat_cmd elemexpr
+          {
+            if ($1 == MATRIX_CMD)
+            {
+              if (iiDeclCommand(&$$,&$2,myynest,$1,&(currRing->idroot), TRUE)) YYERROR;
+            }
+            else if (($1 == INTMAT_CMD)||($1 == BIGINTMAT_CMD))
             {
               if (iiDeclCommand(&$$,&$2,myynest,$1,&($2.req_packhdl->idroot)))
                 YYERROR;
-              v=&$$;
-              h=(idhdl)v->data;
-              delete IDBIMAT(h);
-              IDBIMAT(h) = new bigintmat(r, c, coeffs_BIGINT);
-              if (IDBIMAT(h)==NULL) YYERROR;
-            }
-          }
-        | mat_cmd elemexpr
-          {
-            if ($1 == MATRIX_CMD)
-            {
-              if (iiDeclCommand(&$$,&$2,myynest,$1,&(currRing->idroot), TRUE)) YYERROR;
-            }
-            else if ($1 == INTMAT_CMD)
-            {
-              if (iiDeclCommand(&$$,&$2,myynest,$1,&($2.req_packhdl->idroot)))
-                YYERROR;
-              leftv v=&$$;
-              idhdl h;
-              do
+              if ($1 == INTMAT_CMD)
               {
-                 h=(idhdl)v->data;
-                 delete IDINTVEC(h);
-                 IDINTVEC(h) = new intvec(1,1,0);
-                 v=v->next;
-              } while (v!=NULL);
-            }
-            else /* BIGINTMAT_CMD */
-            {
-              if (iiDeclCommand(&$$,&$2,myynest,$1,&($2.req_packhdl->idroot)))
-                YYERROR;
+                leftv v=&$$;
+                idhdl h;
+                do
+                {
+                  h=(idhdl)v->data;
+                  delete IDINTVEC(h);
+                  IDINTVEC(h) = new intvec(1,1,0);
+                  v=v->next;
+                } while (v!=NULL);
+              }
             }
           }
@@ -1100,9 +1089,6 @@
 
 mat_cmd: MATRIX_CMD
-            { $$ = $1; }
         | INTMAT_CMD
-            { $$ = $1; }
         | BIGINTMAT_CMD
-            { $$ = $1; }
           ;
 
@@ -1344,5 +1330,5 @@
           {
             if (($1!=LIB_CMD)||(jjLOAD($2,TRUE))) YYERROR;
-	    omFree($2);
+            omFree($2);
           }
         ;
Index: Singular/iparith.cc
===================================================================
--- Singular/iparith.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ Singular/iparith.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -1469,30 +1469,7 @@
 static BOOLEAN jjINDEX_V(leftv res, leftv u, leftv v)
 {
-  poly p=(poly)u->CopyD(VECTOR_CMD);
-  poly r=p; // pointer to the beginning of component i
-  poly o=NULL;
+  poly p=(poly)u->Data();
   int i=(int)(long)v->Data();
-  while (p!=NULL)
-  {
-    if (pGetComp(p)!=i)
-    {
-      if (r==p) r=pNext(p);
-      if (o!=NULL)
-      {
-        if (pNext(o)!=NULL) pLmDelete(&pNext(o));
-        p=pNext(o);
-      }
-      else
-        pLmDelete(&p);
-    }
-    else
-    {
-      pSetComp(p, 0);
-      p_SetmComp(p, currRing);
-      o=p;
-      p=pNext(o);
-    }
-  }
-  res->data=(char *)r;
+  res->data=(char *)p_Vec2Poly(p,i,currRing);
   return FALSE;
 }
@@ -6267,4 +6244,17 @@
   }
   return FALSE;
+}
+static BOOLEAN jjSUBST_Bu(leftv res, leftv u, leftv v,leftv w)
+{
+  // generic conversion from polyBucket to poly:
+  // force this to be the first try everytime
+  poly p; int l;
+  sBucket_pt bu=(sBucket_pt)w->CopyD();
+  sBucketDestroyAdd(bu,&p,&l);
+  sleftv tmpw;
+  tmpw.Init();
+  tmpw.rtyp=POLY_CMD;
+  tmpw.data=p;
+  return iiExprArith3(res, iiOp, u, v, &tmpw);
 }
 static BOOLEAN jjSUBST_P(leftv res, leftv u, leftv v,leftv w)
Index: Singular/misc_ip.cc
===================================================================
--- Singular/misc_ip.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ Singular/misc_ip.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -807,5 +807,4 @@
 #endif
 #ifdef HAVE_NTL
-#include <NTL/version.h>
               StringAppend("NTL(%s),",NTL_VERSION);
 #endif
Index: Singular/table.h
===================================================================
--- Singular/table.h	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ Singular/table.h	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -851,4 +851,5 @@
 ,{D(jjSTD_HILB_W),     STD_CMD,    IDEAL_CMD,  IDEAL_CMD,  INTVEC_CMD, INTVEC_CMD, ALLOW_PLURAL |NO_RING}
 ,{D(jjSTD_HILB_W),     STD_CMD,    MODUL_CMD,  MODUL_CMD,  INTVEC_CMD, INTVEC_CMD, ALLOW_PLURAL |NO_RING}
+,{D(jjSUBST_Bu),       SUBST_CMD,  ANY_TYPE,   DEF_CMD,    POLY_CMD,   BUCKET_CMD , ALLOW_PLURAL |ALLOW_RING}
 ,{D(jjSUBST_P),        SUBST_CMD,  POLY_CMD,   POLY_CMD,   POLY_CMD,   POLY_CMD , ALLOW_PLURAL |ALLOW_RING}
 ,{D(jjSUBST_P),        SUBST_CMD,  VECTOR_CMD, VECTOR_CMD, POLY_CMD,   POLY_CMD , ALLOW_PLURAL |ALLOW_RING}
